﻿//
//  Player.m
//  Fussball3d
//
//  Created by Roger Engelbert on 10/29/12.
//  Copyright 2012 DoneWithComputers. All rights reserved.
//
#import "Player.h"
static Isgl3dTextureMaterial * TEXTURE_HEAD_LEFT;
static Isgl3dTextureMaterial * TEXTURE_HEAD_RIGHT;
static Isgl3dTextureMaterial * TEXTURE_HEAD_FRONT;
static Isgl3dTextureMaterial * TEXTURE_HEAD_BACK;
static Isgl3dTextureMaterial * TEXTURE_BRAZIL_LEFT;
static Isgl3dTextureMaterial * TEXTURE_BRAZIL_RIGHT;
static Isgl3dTextureMaterial * TEXTURE_BRAZIL_FRONT;
static Isgl3dTextureMaterial * TEXTURE_BRAZIL_TOP;
static Isgl3dTextureMaterial * TEXTURE_BRAZIL_BACK;
static Isgl3dTextureMaterial * TEXTURE_ARGENTINA_LEFT;
static Isgl3dTextureMaterial * TEXTURE_ARGENTINA_RIGHT;
static Isgl3dTextureMaterial * TEXTURE_ARGENTINA_FRONT;
static Isgl3dTextureMaterial * TEXTURE_ARGENTINA_TOP;
static Isgl3dTextureMaterial * TEXTURE_ARGENTINA_BACK;
static Isgl3dColorMaterial * TEXTURE_SKIN;
static Isgl3dColorMaterial * TEXTURE_SHOES;
static Isgl3dColorMaterial * TEXTURE_HEAD_TOP;
@implementation Player
-(void) dealloc {
	[super dealloc];
}
-(id) initWithView:(Fussball3d *) view withTeam:(int) team at:(CGPoint) position {
	
	self = [super initWithView:view];
	
	if (self != nil) {
		if (TEXTURE_HEAD_LEFT == nil) {
			
			TEXTURE_HEAD_LEFT = [Isgl3dTextureMaterial materialWithTextureFile:@"head_side_left.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_HEAD_RIGHT = [Isgl3dTextureMaterial materialWithTextureFile:@"head_side_right.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_HEAD_FRONT = [Isgl3dTextureMaterial materialWithTextureFile:@"head_side_front.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_HEAD_BACK = [Isgl3dTextureMaterial materialWithTextureFile:@"head_side_back.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			
			
			TEXTURE_BRAZIL_LEFT = [Isgl3dTextureMaterial materialWithTextureFile:@"brazil_side_left.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO] ;
			
			TEXTURE_BRAZIL_RIGHT = [Isgl3dTextureMaterial materialWithTextureFile:@"brazil_side_right.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_BRAZIL_FRONT = [Isgl3dTextureMaterial materialWithTextureFile:@"brazil_side_front.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_BRAZIL_BACK = [Isgl3dTextureMaterial materialWithTextureFile:@"brazil_side_back.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_BRAZIL_TOP = [Isgl3dTextureMaterial materialWithTextureFile:@"brazil_side_top.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			
			TEXTURE_ARGENTINA_LEFT = [Isgl3dTextureMaterial materialWithTextureFile:@"argentina_side_left.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_ARGENTINA_RIGHT = [Isgl3dTextureMaterial materialWithTextureFile:@"argentina_side_right.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_ARGENTINA_TOP = [Isgl3dTextureMaterial materialWithTextureFile:@"argentina_side_top.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_ARGENTINA_FRONT = [Isgl3dTextureMaterial materialWithTextureFile:@"argentina_side_front.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_ARGENTINA_BACK = [Isgl3dTextureMaterial materialWithTextureFile:@"argentina_side_back.png" shininess:0 precision:Isgl3dTexturePrecisionMedium repeatX:NO repeatY:NO];
			
			TEXTURE_SKIN = [Isgl3dColorMaterial materialWithHexColors:@"ffcc99" diffuse:@"ffcc99" specular:@"ffcc99" shininess:0.0];
			TEXTURE_SHOES = [Isgl3dColorMaterial materialWithHexColors:@"003366" diffuse:@"003366" specular:@"003366" shininess:0.0];
			TEXTURE_HEAD_TOP = [Isgl3dColorMaterial materialWithHexColors:@"74553f" diffuse:@"74553f" specular:@"74553f" shininess:0.0];
			
		}
		_x = position.x;
		_y = position.y;
		
		_skin.x = position.x  - _view.screenWidth * 0.5f;
		_skin.y = -PLAYER_HEAD_HEIGHT * 0.5f;
		_skin.z = 0;
		
		
		Isgl3dGLMesh * geometry;
		Isgl3dMeshNode * node;
		Isgl3dMeshNode * body;
		Isgl3dMeshNode * leg;
		
		
        //head material array for multi material cube
		NSArray * headMaterial = [NSArray arrayWithObjects:
															TEXTURE_HEAD_FRONT,
															TEXTURE_HEAD_BACK,
															TEXTURE_HEAD_RIGHT,
															TEXTURE_HEAD_LEFT,
															TEXTURE_HEAD_TOP,
															TEXTURE_SKIN, nil];
		
		 //create head
		 node = [Isgl3dMultiMaterialCube cubeWithDimensionsAndMaterials:headMaterial uvMapArray:nil width:PLAYER_WIDTH * 0.6 height:PLAYER_HEAD_HEIGHT depth:PLAYER_DEPTH nSegmentWidth:2 nSegmentHeight:2 nSegmentDepth:2];
		 node.y = PLAYER_HEAD_HEIGHT * 1.5;
		 [_skin addChild:node];
		 
		 
		 //create body
			
		//body material array for multi material cube
		NSArray *bodyMaterial;
		 if (team == TEAM_1) {
			 bodyMaterial = [NSArray arrayWithObjects:
											 TEXTURE_BRAZIL_FRONT,
											 TEXTURE_BRAZIL_BACK,
											 TEXTURE_BRAZIL_RIGHT,
											 TEXTURE_BRAZIL_LEFT,
											 TEXTURE_BRAZIL_TOP,
											 TEXTURE_SHOES,
											 nil];
			 body = [Isgl3dMultiMaterialCube cubeWithDimensionsAndMaterials:bodyMaterial uvMapArray:nil width:PLAYER_WIDTH height:PLAYER_BODY_HEIGHT depth:PLAYER_DEPTH nSegmentWidth:2 nSegmentHeight:2 nSegmentDepth:2];
		 } else {
			 bodyMaterial = [NSArray arrayWithObjects:
											 TEXTURE_ARGENTINA_FRONT,
											 TEXTURE_ARGENTINA_BACK,
											 TEXTURE_ARGENTINA_RIGHT,
											 TEXTURE_ARGENTINA_LEFT,
											 TEXTURE_ARGENTINA_TOP,
											 TEXTURE_SHOES,
											 nil];
			 body = [Isgl3dMultiMaterialCube cubeWithDimensionsAndMaterials:bodyMaterial uvMapArray:nil width:PLAYER_WIDTH height:PLAYER_BODY_HEIGHT depth:PLAYER_DEPTH nSegmentWidth:2 nSegmentHeight:2 nSegmentDepth:2];
				_skin.rotationY = 180;
		 }
		 body.y = PLAYER_BODY_HEIGHT * 0.5;
		 [_skin addChild:body];
		 
		 
		 //create leg
		 geometry = [Isgl3dCube meshWithGeometry:PLAYER_WIDTH * 0.6 height:PLAYER_LEG_HEIGHT depth:PLAYER_DEPTH nx:2 ny:2];
		 leg = [[[Isgl3dMeshNode alloc] initWithMesh:geometry andMaterial:TEXTURE_SKIN] autorelease];
		 leg.y = body.y - PLAYER_BODY_HEIGHT * 0.5 - PLAYER_LEG_HEIGHT * 0.5;
		 [_skin addChild:leg];
		 
		 
		 //create shoes
		 geometry = [Isgl3dCylinder meshWithGeometry:PLAYER_SHOES_HEIGHT radius:PLAYER_SHOES_RADIUS ns:32 nt:32 openEnded:NO];
		 node = [[[Isgl3dMeshNode alloc] initWithMesh:geometry andMaterial:TEXTURE_SHOES] autorelease];
		 node.y = leg.y - PLAYER_LEG_HEIGHT * 0.5 - PLAYER_SHOES_HEIGHT * 0.5;
		 [_skin addChild:node];
		 
	}
	
	return self;
}
+(float) playerLength {
	return PLAYER_LEG_HEIGHT + PLAYER_BODY_HEIGHT + PLAYER_SHOES_HEIGHT * 0.5f;
}
+(float) playerSquaredRadius {
	return PLAYER_RADIUS * PLAYER_RADIUS;
}

@end