/*
 * iSGL3D: http://isgl3d.com
 *
 * Copyright (c) 2010-2011 Stuart Caunt
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#import <OpenGLES/ES2/gl.h>

#import "Isgl3dGLRenderer.h"

@class Isgl3dGLRenderer2State;
@class Isgl3dShader;

/**
 * __isgl3d_internal__ Internal class of the iSGL3D framework
 */
@interface Isgl3dGLRenderer2 : Isgl3dGLRenderer {

@private
	Isgl3dMatrix4 _mvpMatrix;
	Isgl3dMatrix4 _mvMatrix;

	Isgl3dMatrix4 _lightViewProjectionMatrix;
	Isgl3dMatrix4 _lightModelViewProjectionMatrix;

	
	BOOL _shadowMapActive;

	unsigned int _currentVBOIndex;

	Isgl3dGLRenderer2State * _currentState;
	Isgl3dGLRenderer2State * _previousState;

	NSMutableDictionary * _internalShaders;
	NSMutableDictionary * _customShaders;
	Isgl3dShader * _activeShader;
	
	unsigned int _renderedObjects;

	GLuint _currentElementBufferId;
}

- (id) init;

- (void) setShaderActive:(Isgl3dShader *)shader;

@end
